version: '3.3'

services:
  db:
    container_name: instamini_mysql
    build: ./mysql
    restart: always
    cap_add:
      - SYS_NICE
    ports:
      - '3307:3306'
    volumes:
      - instamini-db-v:/var/lib/mysql

  elasticsearch:
    container_name: instamini_elasticsearch
    build: ./elasticsearch
    ports:
      - "9200:9200"
      - "9300:9300"
    volumes:
      - instamini-elasticsearch-v:/usr/share/elasticsearch/data

  elasticsearch_configurer:
    container_name: instamini_elasticsearch_configurer
    build: ./elasticsearch_configurer
    depends_on:
      - "elasticsearch"
    restart: on-failure

  logstash:
    container_name: instamini_logstash
    build: ./logstash
    depends_on:
      - "elasticsearch"
      - "db"
    restart: on-failure
    
  instamini:
    container_name: instamini_micronaut
    build: ./instamini_micronaut
    ports:
      - '8080:8080'
    depends_on:
      - "db"
      - "elasticsearch"
    restart: on-failure

  react-frontend:
    container_name: instamini_frontend
    build: ./react-frontend
    ports:
      - '3001:3001'
    depends_on:
      - "db"
      - "instamini"
    restart: on-failure
    stdin_open: true

  prometheus:
    container_name: instamini_prometheus
    build: ./prometheus
    ports:
      - '9090:9090'
    depends_on:
      - "instamini"
    volumes:
      - instamini-prometheus-data:/prometheus

  grafana:
    container_name: instamini_grafana
    build: ./grafana
    ports:
      - '3000:3000'
    depends_on:
      - "prometheus"
    volumes:
      - instamini-grafana-storage:/var/lib/grafana

volumes:
  instamini-db-v:
  instamini-elasticsearch-v:
  instamini-grafana-storage:
  instamini-prometheus-data:
